//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>

#include "MemoFrm.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMemoForm *MemoForm;
//---------------------------------------------------------------------------
__fastcall TMemoForm::TMemoForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMemoForm::AfterConstruction()
{
   TForm::AfterConstruction();

   AnsiString IniRec;
   TIniFile * IniFile = new TIniFile(ChangeFileExt(Application->ExeName,".ini"));
   try {
      IniRec = IniFile->ReadString(Name,"FormPos","");
      ReadFromIni(IniFile);
   } __finally {
      delete IniFile;
   }

   int showCmd,top,left,height,width,dif;
   if (sscanf(IniRec.c_str()," %x %d %d %d %d",
                &showCmd,&left,&top,&width,&height) == 5) {
      dif=(top + height) - Screen->Height;
      if (dif > 0) top -= dif;
      if (top < 0) top = 0;
      dif=(left + width) - Screen->Width;
      if (dif > 0) left -= dif;
      if (left < 0) left = 0;
      Top=top; Left=left; Height=height; Width=width;
      switch (showCmd) {
         case SW_SHOWNORMAL:
         case SW_SHOWMINIMIZED:  // don't show minimized
            WindowState = wsNormal; break;
         case SW_SHOWMAXIMIZED:
            WindowState = wsMaximized; break;
      }
   }

   if (!Icon) Icon->Assign(Application->Icon);
}
//---------------------------------------------------------------------------
void __fastcall TMemoForm::BeforeDestruction()
{
   TForm::BeforeDestruction();

   WINDOWPLACEMENT Placement;
   Placement.length = sizeof(WINDOWPLACEMENT);
   GetWindowPlacement(Handle,&Placement);
   char IniRec[64];
   sprintf(IniRec," %X %d %d %d %d",
      Placement.showCmd,
      Placement.rcNormalPosition.left,
      Placement.rcNormalPosition.top,
      Placement.rcNormalPosition.right - Placement.rcNormalPosition.left + 1,
      Placement.rcNormalPosition.bottom - Placement.rcNormalPosition.top + 1);

   TIniFile * IniFile = new TIniFile(ChangeFileExt(Application->ExeName,".ini"));
   try {
      IniFile->WriteString(Name,"FormPos",IniRec);
      WriteToIni(IniFile);
   } __finally {
      delete IniFile;
   }
}
//---------------------------------------------------------------------------

