//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "OVPreviewFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MemoFRM"
#pragma resource "*.dfm"
#pragma link "MemoFrm"
TOVPreviewForm *OVPreviewForm;
//---------------------------------------------------------------------------
class TPreviewPage: public TTabSheet
{
public:
   __fastcall TPreviewPage(TComponent * Owner);
   TOVPreview * OVPreview;
};
//---------------------------------------------------------------------------
__fastcall TPreviewPage::TPreviewPage(TComponent * Owner)
   : TTabSheet(Owner)
{
   OVPreview = new TOVPreview(this);
   OVPreview->Parent = this;
   OVPreview->Align = alClient;
}
//---------------------------------------------------------------------------
__fastcall TOVPreviewForm::TOVPreviewForm(TComponent* Owner)
   : TMemoForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::AddDoc(TCustomOVPrintout * OVPrintout, bool TakeOwnership)
{
   TPreviewPage * Page = new TPreviewPage(this);
   Page->PageControl = Pages;
//   Page->Caption = OVPrintout->Title;
   Page->OVPreview->TakeOwnership = TakeOwnership;
   Page->OVPreview->OnPrintoutChange = PreviewPrintoutChange;
   Page->OVPreview->OnPageChange = PreviewPageChange;
   Page->OVPreview->OnZoomChange = PreviewZoomChange;
   Page->OVPreview->OVPrintout = OVPrintout;
   Page->OVPreview->Visible = true;
   Pages->ActivePage = Page;
   PagesChange(Pages);
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::PagesChange(TObject *Sender)
{
   TOVPreview * AP = ActivePreview();
   if (AP) {
      Caption = AP->OVPrintout->Title + " - preview";
      PreviewPageChange(AP);
      switch (AP->ZoomKind) {
         case TOVPreview::zkWidth:  btnZoomWidth->Down = true; break;
         case TOVPreview::zkHeight: btnZoomHeight->Down = true; break;
         case TOVPreview::zkPage:   btnZoomPage->Down = true; break;
         case TOVPreview::zkAbs:
            if (AP->Zoom == 100) {
               btnZoom100->Down = true;
            } else {
               btnZoomX->Down = true;
            }
         break;
      }
      edZoom->Text = IntToStr(AP->Zoom);
   } else {
      Caption = "Preview";
      StatusBar->SimpleText = "Not ready";
      edPage->Text = "";
      btnZoomWidth->Down = true;
      edZoom->Text = "";
   }
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::PreviewPrintoutChange(TObject * Sender)
{
   TOVPreview * AP = static_cast<TOVPreview *>(Sender);
   int i;
   TPreviewPage * PreviewPage;
   for (i = Pages->PageCount - 1; i >= 0; i--) {
      PreviewPage = static_cast<TPreviewPage *>(Pages->Pages[i]);
      if (PreviewPage->OVPreview == AP) {
         if (AP->OVPrintout) {
            PreviewPage->Caption = AP->OVPrintout->Title;
         } else {
            delete PreviewPage;
         }
         break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::PreviewPageChange(TObject * Sender)
{
   TOVPreview * AP = static_cast<TOVPreview *>(Sender);
   edPage->Text = IntToStr(AP->CurrentPage);
   AnsiString S;
   S.sprintf("Page %d of %d",AP->CurrentPage,AP->OVPrintout->PageCount);
   StatusBar->SimpleText = S;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::PreviewZoomChange(TObject * Sender)
{
   TOVPreview * AP = static_cast<TOVPreview *>(Sender);
   edZoom->Text = IntToStr(AP->Zoom);
}
//---------------------------------------------------------------------------
TOVPreview * __fastcall TOVPreviewForm::ActivePreview()
{
   TOVPreview * OVPreview = 0;
   TPreviewPage * ActivePage = static_cast<TPreviewPage *>(Pages->ActivePage);
   if (ActivePage) {
      TCustomOVPrintout * Printout = ActivePage->OVPreview->OVPrintout;
      if (Printout && Printout->Done) OVPreview = ActivePage->OVPreview;
   }
   return OVPreview;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actFirstPageUpdate(TObject *Sender)
{
   TOVPreview * AP = ActivePreview();
   static_cast<TAction *>(Sender)->Enabled = AP && (AP->CurrentPage > 1);
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actLastPageUpdate(TObject *Sender)
{
   TOVPreview * AP = ActivePreview();
   static_cast<TAction *>(Sender)->Enabled = AP && (AP->CurrentPage < AP->OVPrintout->PageCount);
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actFirstPageExecute(TObject *Sender)
{
   ActivePreview()->CurrentPage = 1;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actPrevPageExecute(TObject *Sender)
{
   ActivePreview()->CurrentPage--;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actNextPageExecute(TObject *Sender)
{
   ActivePreview()->CurrentPage++;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actLastPageExecute(TObject *Sender)
{
   TOVPreview * AP = ActivePreview();
   AP->CurrentPage = AP->OVPrintout->PageCount;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actTopExecute(TObject *Sender)
{
   ActivePreview()->CurrentPage = 1;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actPrevExecute(TObject *Sender)
{
   ActivePreview()->ScrollUp();
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actNextExecute(TObject *Sender)
{
   ActivePreview()->ScrollDown();
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actEndExecute(TObject *Sender)
{
   ActivePreview()->ScrollToEnd();
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::edPageKeyPress(TObject *Sender, char &Key)
{
   if (Key == '\xD') {
      try {
         int PageNo = edPage->Text.Trim().ToInt();
         TOVPreview * AP = ActivePreview();
         if (AP) AP->CurrentPage = PageNo;
      } catch (EConvertError &) {
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actAPUpdate(TObject *Sender)
{
   static_cast<TAction *>(Sender)->Enabled = ActivePreview() != 0;
}
//---------------------------------------------------------------------------

void __fastcall TOVPreviewForm::actZoomWidthExecute(TObject *Sender)
{
   ActivePreview()->ZoomKind = TOVPreview::zkWidth;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actZoomHeightExecute(TObject *Sender)
{
   ActivePreview()->ZoomKind = TOVPreview::zkHeight;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actZoomPageExecute(TObject *Sender)
{
   ActivePreview()->ZoomKind = TOVPreview::zkPage;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actZoom100Execute(TObject *Sender)
{
   TOVPreview * AP = ActivePreview();
   AP->Zoom = 100;
   AP->ZoomKind = TOVPreview::zkAbs;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actZoomXExecute(TObject *Sender)
{
   int Zoom;
   TOVPreview * AP = ActivePreview();
   try {
      Zoom = edZoom->Text.ToInt();
      if (Zoom < 10) Zoom = 10;
   } catch (EConvertError &) {
      Zoom = 100;
   }
//   edZoom->Text = Zoom;
   AP->Zoom = Zoom;
   AP->ZoomKind = TOVPreview::zkAbs;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::edZoomKeyPress(TObject *Sender, char &Key)
{
   if (Key == '\xD') {
      btnZoomX->Down = true;
      btnZoomX->Click();
   }
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actPrintExecute(TObject *Sender)
{
   ActivePreview()->OVPrintout->Print(Sender == actPrintWithDlg);
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actOpenExecute(TObject *Sender)
{
   if (OpenDialog->Execute()) {
      TCustomOVPrintout * OVPtr = new TCustomOVPrintout(this);
      OVPtr->LoadFromFile(OpenDialog->FileName);
      AddDoc(OVPtr,true);
   }
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actSaveExecute(TObject *Sender)
{
   if (SaveDialog->Execute()) {
      ActivePreview()->OVPrintout->SaveToFile(SaveDialog->FileName);
   }
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actCloseDocUpdate(TObject *Sender)
{
   static_cast<TAction *>(Sender)->Enabled = Pages->ActivePage != 0;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actCloseDocExecute(TObject *Sender)
{
   delete Pages->ActivePage;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::acCloseAllDocsExecute(TObject *Sender)
{
   while (Pages->ActivePage) delete Pages->ActivePage;
}
//---------------------------------------------------------------------------
void __fastcall TOVPreviewForm::actCloseExecute(TObject *Sender)
{
   if (FormState.Contains(fsModal)) {
      ModalResult = mrCancel;
   } else {
      Close();
   }
}
//---------------------------------------------------------------------------


